package lab.game;
import javax.xml.stream.events.StartDocument;
import java.util.*;

public class Bishop extends Piece{
  public Bishop(char x, int y, boolean color, String name){
    super(x, y, color, name);
  }

  /**
   * Check if can move to (X, Y)
   * @author Omiid
   * @param x The X-Axis
   * @param y The Y-Axis
   * @return true if can move
   */
  public boolean canMove(char x, int y){ // Ignore the presence of other pieces
    if( Math.abs(this.x - x) != 0 && Math.abs(this.y - y) != 0 && Math.abs((float)(this.x - x) / (this.y - y)) == 1 ){

      return true;
    }
    return false;
  }

  /**
   * Check if can move to (X, Y) : Used for queen class
   * @author Omiid
   * @param p the piece to move
   * @param x The X-Axis
   * @param y The Y-Axis
   * @return true if can move
   */
  public static boolean canMove(Piece p, char x, int y){ // Ignore the presence of other pieces
    if(  Math.abs(p.x - x) != 0 && Math.abs(p.y - y) != 0 && Math.abs((float)(p.x - x) / (p.y - y)) == 1 ){

      return true;
    }
    return false;
  }

  /**
   * Check if way is free to go
   *
   * @param p the piece to check
   * @param pieces ArrayList of all pieces
   * @param x The X-Axis
   * @param y The Y-Axis
   * @author Omiid
   * @return true if is free to go
   */
  public static boolean checkWay(Piece p, ArrayList<Piece> pieces, char x, int y){
    if( p.x - x == 0 ){

      return false;
    }
    if( p.y - y == 0 ){

      return false;
    }
    int xShift = (x - p.x) / Math.abs(x - p.x);
    int yShift = (y - p.y) / Math.abs(y - p.y);
    int i = 1;
    while( x != (char)(p.x + i * xShift) && y != p.y + i * yShift ){
      if( checkTaken(pieces, (char)(p.x + i * xShift), p.y + i * yShift) != null && !(checkTaken(pieces, (char)(p.x + i * xShift), p.y + i * yShift) instanceof King) ){

        return false;
      }
      i++;
    }
    return true;
  }

  /**
   * Check if way is free to go
   * @param pieces ArrayList of all pieces
   * @param x The X-Axis
   * @param y The Y-Axis
   * @author Omiid
   * @return true if is free to go
   */
  public boolean checkWay(ArrayList<Piece> pieces, char x, int y){
    int xShift = (x - this.x) / Math.abs(x - this.x);
    int yShift = (y - this.y) / Math.abs(y - this.y);
    int i = 1;
    while( x != (char)(this.x + i * xShift) && y != this.y + i * yShift ){
      if( checkTaken(pieces, (char)(this.x + i * xShift), this.y + i * yShift) != null && !(checkTaken(pieces, (char)(this.x + i * xShift), this.y + i * yShift) instanceof King) ){

        return false;
      }
      i++;
    }
    return true;
  }
}
